<?php

namespace eContract;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfDealerDBA' => '\\eContract\\ArrayType\\ArrayOfDealerDBA',
            'DealerDBA' => '\\eContract\\StructType\\DealerDBA',
            'ExtensionDataObject' => '\\eContract\\StructType\\ExtensionDataObject',
            'ArrayOfDealerEmail' => '\\eContract\\ArrayType\\ArrayOfDealerEmail',
            'DealerEmail' => '\\eContract\\StructType\\DealerEmail',
            'DealerInfo' => '\\eContract\\StructType\\DealerInfo',
            'MoniNetUserInfo' => '\\eContract\\StructType\\MoniNetUserInfo',
            'ArrayOfString' => '\\eContract\\ArrayType\\ArrayOfString',
            'MoniNetUserInfo2' => '\\eContract\\StructType\\MoniNetUserInfo2',
            'ArrayOfDealerLicense' => '\\eContract\\ArrayType\\ArrayOfDealerLicense',
            'DealerLicense' => '\\eContract\\StructType\\DealerLicense',
            'ArrayOfstring' => '\\eContract\\ArrayType\\ArrayOfstring_1',
            'ArrayOfKeyValueOfstringstring' => '\\eContract\\ArrayType\\ArrayOfKeyValueOfstringstring',
            'KeyValueOfstringstring' => '\\eContract\\StructType\\KeyValueOfstringstring',
            'ArrayOfKeyValueOfstringanyType' => '\\eContract\\ArrayType\\ArrayOfKeyValueOfstringanyType',
            'KeyValueOfstringanyType' => '\\eContract\\StructType\\KeyValueOfstringanyType',
            'AuthenticationResult' => '\\eContract\\StructType\\AuthenticationResult',
            'ArrayOfOptionListing' => '\\eContract\\ArrayType\\ArrayOfOptionListing',
            'OptionListing' => '\\eContract\\StructType\\OptionListing',
            'AuthenticationResult2' => '\\eContract\\StructType\\AuthenticationResult2',
            'ArrayOfProgramDiscounts' => '\\eContract\\ArrayType\\ArrayOfProgramDiscounts',
            'ProgramDiscounts' => '\\eContract\\StructType\\ProgramDiscounts',
            'StatusSearch' => '\\eContract\\StructType\\StatusSearch',
            'ArrayOfStatusSearch' => '\\eContract\\ArrayType\\ArrayOfStatusSearch',
            'ContractDocument' => '\\eContract\\StructType\\ContractDocument',
            'ArrayOfContactItem' => '\\eContract\\ArrayType\\ArrayOfContactItem',
            'ContactItem' => '\\eContract\\StructType\\ContactItem',
            'ArrayOfEquipmentItem' => '\\eContract\\ArrayType\\ArrayOfEquipmentItem',
            'EquipmentItem' => '\\eContract\\StructType\\EquipmentItem',
            'PaymentItem' => '\\eContract\\StructType\\PaymentItem',
            'ContractDocument2' => '\\eContract\\StructType\\ContractDocument2',
            'ContractDocumentConsumer' => '\\eContract\\StructType\\ContractDocumentConsumer',
            'CreateContractResult' => '\\eContract\\StructType\\CreateContractResult',
            'VoidEnvelopeResult' => '\\eContract\\StructType\\VoidEnvelopeResult',
            'ContractEnvelope' => '\\eContract\\StructType\\ContractEnvelope',
            'CreateContractConsumerResult' => '\\eContract\\StructType\\CreateContractConsumerResult',
            'ErrorResponse' => '\\eContract\\StructType\\ErrorResponse',
            'ValidationResult' => '\\eContract\\StructType\\ValidationResult',
            'GenericResult' => '\\eContract\\StructType\\GenericResult',
            'DocuSignTemplateCreditAuthDocument' => '\\eContract\\StructType\\DocuSignTemplateCreditAuthDocument',
            'DocuSignTemplateBaseObject' => '\\eContract\\StructType\\DocuSignTemplateBaseObject',
            'ArrayOfDocumentSignatures' => '\\eContract\\ArrayType\\ArrayOfDocumentSignatures',
            'DocumentSignatures' => '\\eContract\\StructType\\DocumentSignatures',
            'DocuSignTemplateCancelLetter' => '\\eContract\\StructType\\DocuSignTemplateCancelLetter',
            'DocuSignTemplateNonSolicitAgreement' => '\\eContract\\StructType\\DocuSignTemplateNonSolicitAgreement',
            'CreditAuthHeader' => '\\eContract\\StructType\\CreditAuthHeader',
            'ArrayOfCreditAuthHeader' => '\\eContract\\ArrayType\\ArrayOfCreditAuthHeader',
            'APIVersion' => '\\eContract\\StructType\\APIVersion',
            'APIVersionResponse' => '\\eContract\\StructType\\APIVersionResponse',
            'AuthenticateUser' => '\\eContract\\StructType\\AuthenticateUser',
            'AuthenticateUserResponse' => '\\eContract\\StructType\\AuthenticateUserResponse',
            'SearchContracts' => '\\eContract\\StructType\\SearchContracts',
            'SearchContractsResponse' => '\\eContract\\StructType\\SearchContractsResponse',
            'CreateContract' => '\\eContract\\StructType\\CreateContract',
            'CreateContractResponse' => '\\eContract\\StructType\\CreateContractResponse',
            'NextSigner' => '\\eContract\\StructType\\NextSigner',
            'NextSignerResponse' => '\\eContract\\StructType\\NextSignerResponse',
            'VoidContract' => '\\eContract\\StructType\\VoidContract',
            'VoidContractResponse' => '\\eContract\\StructType\\VoidContractResponse',
            'GetContract' => '\\eContract\\StructType\\GetContract',
            'GetContractResponse' => '\\eContract\\StructType\\GetContractResponse',
            'GetContractAsPrimary' => '\\eContract\\StructType\\GetContractAsPrimary',
            'GetContractAsPrimaryResponse' => '\\eContract\\StructType\\GetContractAsPrimaryResponse',
            'GetContractDocumentConsumer' => '\\eContract\\StructType\\GetContractDocumentConsumer',
            'GetContractDocumentConsumerResponse' => '\\eContract\\StructType\\GetContractDocumentConsumerResponse',
            'SendQuoteEmail' => '\\eContract\\StructType\\SendQuoteEmail',
            'SendQuoteEmailResponse' => '\\eContract\\StructType\\SendQuoteEmailResponse',
            'GetContractID' => '\\eContract\\StructType\\GetContractID',
            'GetContractIDResponse' => '\\eContract\\StructType\\GetContractIDResponse',
            'AuthenticateUser2' => '\\eContract\\StructType\\AuthenticateUser2',
            'AuthenticateUser2Response' => '\\eContract\\StructType\\AuthenticateUser2Response',
            'CreateContract2' => '\\eContract\\StructType\\CreateContract2',
            'CreateContract2Response' => '\\eContract\\StructType\\CreateContract2Response',
            'CreateContractConsumer' => '\\eContract\\StructType\\CreateContractConsumer',
            'CreateContractConsumerResponse' => '\\eContract\\StructType\\CreateContractConsumerResponse',
            'GetPerformCallbackToPartnerAPIFlag' => '\\eContract\\StructType\\GetPerformCallbackToPartnerAPIFlag',
            'GetPerformCallbackToPartnerAPIFlagResponse' => '\\eContract\\StructType\\GetPerformCallbackToPartnerAPIFlagResponse',
            'ValidateContract2' => '\\eContract\\StructType\\ValidateContract2',
            'ValidateContract2Response' => '\\eContract\\StructType\\ValidateContract2Response',
            'SendQuoteEmail2' => '\\eContract\\StructType\\SendQuoteEmail2',
            'SendQuoteEmail2Response' => '\\eContract\\StructType\\SendQuoteEmail2Response',
            'UploadAttachment' => '\\eContract\\StructType\\UploadAttachment',
            'UploadAttachmentResponse' => '\\eContract\\StructType\\UploadAttachmentResponse',
            'DeleteAttachment' => '\\eContract\\StructType\\DeleteAttachment',
            'DeleteAttachmentResponse' => '\\eContract\\StructType\\DeleteAttachmentResponse',
            'SendNonSolicitAgreement' => '\\eContract\\StructType\\SendNonSolicitAgreement',
            'SendNonSolicitAgreementResponse' => '\\eContract\\StructType\\SendNonSolicitAgreementResponse',
            'SendCreditAuthorization' => '\\eContract\\StructType\\SendCreditAuthorization',
            'SendCreditAuthorizationResponse' => '\\eContract\\StructType\\SendCreditAuthorizationResponse',
            'RegisterNotificationUrl' => '\\eContract\\StructType\\RegisterNotificationUrl',
            'RegisterNotificationUrlResponse' => '\\eContract\\StructType\\RegisterNotificationUrlResponse',
            'ContractReadyForArchival' => '\\eContract\\StructType\\ContractReadyForArchival',
            'ContractReadyForArchivalResponse' => '\\eContract\\StructType\\ContractReadyForArchivalResponse',
            'SearchCreditAuth' => '\\eContract\\StructType\\SearchCreditAuth',
            'SearchCreditAuthResponse' => '\\eContract\\StructType\\SearchCreditAuthResponse',
            'SendCancelLetter' => '\\eContract\\StructType\\SendCancelLetter',
            'SendCancelLetterResponse' => '\\eContract\\StructType\\SendCancelLetterResponse',
            'ResendEnvelope' => '\\eContract\\StructType\\ResendEnvelope',
            'ResendEnvelopeResponse' => '\\eContract\\StructType\\ResendEnvelopeResponse',
        );
    }
}
