<?php

namespace eContract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DocuSignTemplateCancelLetter StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DocuSignTemplateCancelLetter
 * @subpackage Structs
 */
class DocuSignTemplateCancelLetter extends DocuSignTemplateBaseObject
{
    /**
     * The ContractNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContractNumber;
    /**
     * The CustomerEmail
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerEmail;
    /**
     * The CustomerName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerName;
    /**
     * The CustomerNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerNumber;
    /**
     * The DealerPortalPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DealerPortalPassword;
    /**
     * The DealerPortalUsername
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DealerPortalUsername;
    /**
     * The DocumentStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DocumentStatus;
    /**
     * The SiteNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SiteNumber;
    /**
     * Constructor method for DocuSignTemplateCancelLetter
     * @uses DocuSignTemplateCancelLetter::setContractNumber()
     * @uses DocuSignTemplateCancelLetter::setCustomerEmail()
     * @uses DocuSignTemplateCancelLetter::setCustomerName()
     * @uses DocuSignTemplateCancelLetter::setCustomerNumber()
     * @uses DocuSignTemplateCancelLetter::setDealerPortalPassword()
     * @uses DocuSignTemplateCancelLetter::setDealerPortalUsername()
     * @uses DocuSignTemplateCancelLetter::setDocumentStatus()
     * @uses DocuSignTemplateCancelLetter::setSiteNumber()
     * @param string $contractNumber
     * @param string $customerEmail
     * @param string $customerName
     * @param string $customerNumber
     * @param string $dealerPortalPassword
     * @param string $dealerPortalUsername
     * @param string $documentStatus
     * @param string $siteNumber
     */
    public function __construct($contractNumber = null, $customerEmail = null, $customerName = null, $customerNumber = null, $dealerPortalPassword = null, $dealerPortalUsername = null, $documentStatus = null, $siteNumber = null)
    {
        $this
            ->setContractNumber($contractNumber)
            ->setCustomerEmail($customerEmail)
            ->setCustomerName($customerName)
            ->setCustomerNumber($customerNumber)
            ->setDealerPortalPassword($dealerPortalPassword)
            ->setDealerPortalUsername($dealerPortalUsername)
            ->setDocumentStatus($documentStatus)
            ->setSiteNumber($siteNumber);
    }
    /**
     * Get ContractNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContractNumber()
    {
        return isset($this->ContractNumber) ? $this->ContractNumber : null;
    }
    /**
     * Set ContractNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contractNumber
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setContractNumber($contractNumber = null)
    {
        // validation for constraint: string
        if (!is_null($contractNumber) && !is_string($contractNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contractNumber)), __LINE__);
        }
        if (is_null($contractNumber) || (is_array($contractNumber) && empty($contractNumber))) {
            unset($this->ContractNumber);
        } else {
            $this->ContractNumber = $contractNumber;
        }
        return $this;
    }
    /**
     * Get CustomerEmail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerEmail()
    {
        return isset($this->CustomerEmail) ? $this->CustomerEmail : null;
    }
    /**
     * Set CustomerEmail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerEmail
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setCustomerEmail($customerEmail = null)
    {
        // validation for constraint: string
        if (!is_null($customerEmail) && !is_string($customerEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerEmail)), __LINE__);
        }
        if (is_null($customerEmail) || (is_array($customerEmail) && empty($customerEmail))) {
            unset($this->CustomerEmail);
        } else {
            $this->CustomerEmail = $customerEmail;
        }
        return $this;
    }
    /**
     * Get CustomerName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerName()
    {
        return isset($this->CustomerName) ? $this->CustomerName : null;
    }
    /**
     * Set CustomerName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerName
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setCustomerName($customerName = null)
    {
        // validation for constraint: string
        if (!is_null($customerName) && !is_string($customerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerName)), __LINE__);
        }
        if (is_null($customerName) || (is_array($customerName) && empty($customerName))) {
            unset($this->CustomerName);
        } else {
            $this->CustomerName = $customerName;
        }
        return $this;
    }
    /**
     * Get CustomerNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerNumber()
    {
        return isset($this->CustomerNumber) ? $this->CustomerNumber : null;
    }
    /**
     * Set CustomerNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerNumber
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setCustomerNumber($customerNumber = null)
    {
        // validation for constraint: string
        if (!is_null($customerNumber) && !is_string($customerNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerNumber)), __LINE__);
        }
        if (is_null($customerNumber) || (is_array($customerNumber) && empty($customerNumber))) {
            unset($this->CustomerNumber);
        } else {
            $this->CustomerNumber = $customerNumber;
        }
        return $this;
    }
    /**
     * Get DealerPortalPassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDealerPortalPassword()
    {
        return isset($this->DealerPortalPassword) ? $this->DealerPortalPassword : null;
    }
    /**
     * Set DealerPortalPassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dealerPortalPassword
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setDealerPortalPassword($dealerPortalPassword = null)
    {
        // validation for constraint: string
        if (!is_null($dealerPortalPassword) && !is_string($dealerPortalPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dealerPortalPassword)), __LINE__);
        }
        if (is_null($dealerPortalPassword) || (is_array($dealerPortalPassword) && empty($dealerPortalPassword))) {
            unset($this->DealerPortalPassword);
        } else {
            $this->DealerPortalPassword = $dealerPortalPassword;
        }
        return $this;
    }
    /**
     * Get DealerPortalUsername value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDealerPortalUsername()
    {
        return isset($this->DealerPortalUsername) ? $this->DealerPortalUsername : null;
    }
    /**
     * Set DealerPortalUsername value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dealerPortalUsername
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setDealerPortalUsername($dealerPortalUsername = null)
    {
        // validation for constraint: string
        if (!is_null($dealerPortalUsername) && !is_string($dealerPortalUsername)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dealerPortalUsername)), __LINE__);
        }
        if (is_null($dealerPortalUsername) || (is_array($dealerPortalUsername) && empty($dealerPortalUsername))) {
            unset($this->DealerPortalUsername);
        } else {
            $this->DealerPortalUsername = $dealerPortalUsername;
        }
        return $this;
    }
    /**
     * Get DocumentStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDocumentStatus()
    {
        return isset($this->DocumentStatus) ? $this->DocumentStatus : null;
    }
    /**
     * Set DocumentStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $documentStatus
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setDocumentStatus($documentStatus = null)
    {
        // validation for constraint: string
        if (!is_null($documentStatus) && !is_string($documentStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($documentStatus)), __LINE__);
        }
        if (is_null($documentStatus) || (is_array($documentStatus) && empty($documentStatus))) {
            unset($this->DocumentStatus);
        } else {
            $this->DocumentStatus = $documentStatus;
        }
        return $this;
    }
    /**
     * Get SiteNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSiteNumber()
    {
        return isset($this->SiteNumber) ? $this->SiteNumber : null;
    }
    /**
     * Set SiteNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $siteNumber
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public function setSiteNumber($siteNumber = null)
    {
        // validation for constraint: string
        if (!is_null($siteNumber) && !is_string($siteNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($siteNumber)), __LINE__);
        }
        if (is_null($siteNumber) || (is_array($siteNumber) && empty($siteNumber))) {
            unset($this->SiteNumber);
        } else {
            $this->SiteNumber = $siteNumber;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eContract\StructType\DocuSignTemplateCancelLetter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
